/*-
 * %%----------------------------------------------------------------------------------------------
 * Solidify Framework - Solidify Frontend - data-table-component.model.ts
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2023 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

import {CoreAbstractComponent} from "../../components/core-abstract/core-abstract.component";
import {BaseResourceType} from "../dto/base-resource.model";
import {DataTableColumns} from "./data-table-columns.model";
import {DataTableComponentInput} from "./data-table-component-input.model";

export interface DataTableComponent<TResource extends BaseResourceType = any> {
  /**
   * The component to instanciate
   */
  componentType?: typeof CoreAbstractComponent | any;
  /**
   * A list of inputs managed by the component instanciate
   */
  inputs?: DataTableComponentInput[];
  width?: string | undefined;
  conditionalDisplay?: (rowData: TResource, col: DataTableColumns<TResource>) => boolean;
}
